%

%%%%%%%%%%  %                 %       %%%%%%%%%%%%%%%%
%           %                % %             %
%           %               %   %            %
%%%%%%%%    %              %     %           %
%           %             %%%%%%%%%          %
%           %            %         %         % 
%           %%%%%%%%%%  %           %        %

%Till here the calculation of the drainage path for 4 different cell forms
%is finished. now we will start new calculations for flat cells

% if the cell is Flat
function [FP1,FP2,FP3,FP4,FP5,FP6,FP7,FP8,Check_Matrix]=FLAT_Flow_in(FP1,FP2,FP3,FP4,FP5,FP6,FP7,FP8,Check_Matrix,ZT,Classification_matrix,nrows,ncols)
%coordinates and numbering a 3*3 window cells
    %-------------------------
    %| 8  |   1   |   2   |
    %| 7  |   10  |   3   |
    %| 6  |   5   |   4   |
    %-------------------------
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Contradictive=zeros(nrows,ncols);

     contradictivecells=0;
          contradictivecells2=0;

    cross=0; %temp to calculate howmany cross flow we had      
   
 [tr,tc]=find(Check_Matrix ==0);
[n,trash]=size(tr); %find n the size of that matrix
flat_cells_vector=zeros(nrows,ncols);         
counter=n;         
kk=8;

while kk > 0

    %K is the number of neighbors cells with defined flow paths
    %k will go from 8 to 1
     
% matrix the numbers in this matrix will be change acording to the number
%of cell with defined flow path around each cell.
%cellsleft=sum(sum(Check_Matrix ==0))


for k=1:n %Go through all flat cells
    %coordinates and numbering a 3*3 window cells
    %-------------------------
    %| 1  |   2   |   3   |
    %| 8  |   9   |   4   |
    %| 7  |   6   |   5   |
    %-------------------------
    
     if tr(k)>1 && tc(k)>1 && tr(k)<nrows && tc(k)< ncols %excluding the boundary cells    
        %put the cells around each no data cell in a searching window
        if Check_Matrix(tr(k),tc(k)) == 0 && Classification_matrix(tr(k),tc(k)) == 3
          Cell8=Check_Matrix(tr(k)-1,tc(k)-1); Cell1=Check_Matrix(tr(k)-1,tc(k)); Cell2=Check_Matrix(tr(k)-1,tc(k)+1);...
            Cell3=Check_Matrix(tr(k),tc(k)+1);Cell4=Check_Matrix(tr(k)+1,tc(k)+1);...
            Cell5=Check_Matrix(tr(k)+1,tc(k)); Cell6=Check_Matrix(tr(k)+1,tc(k)-1); Cell7=Check_Matrix(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];
      % give the sum of the around cells to the centre cell
    flat_cells_vector(tr(k),tc(k))= nansum(Cellsmat);
        end
    end
end

kk=max(max(flat_cells_vector))

    %end of number of neighbors calculations
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
for k=1:n %Go through all the flat cells
    
% go through all cells, search for cells with the highest number of defined
%flow path search for the value larger of equal k
%put all cells aorund this cell in a matrix and do the same for all 8
%directions 
if flat_cells_vector(tr(k),tc(k)) >= kk && Check_Matrix(tr(k),tc(k)) == 0 ...
  && tr(k)>1 && tc(k)>1 && tr(k)<nrows && tc(k)< ncols && Classification_matrix(tr(k),tc(k)) == 3 %excluding the boundary cells
   %P=1
   %roww=tr(k)
   %coll=tc(k)
     %FP1   
       Cell8=FP1(tr(k)-1,tc(k)-1); Cell1=FP1(tr(k)-1,tc(k)); Cell2=FP1(tr(k)-1,tc(k)+1);...
            Cell3=FP1(tr(k),tc(k)+1);Cell4=FP1(tr(k)+1,tc(k)+1);...
            Cell5=FP1(tr(k)+1,tc(k)); Cell6=FP1(tr(k)+1,tc(k)-1); Cell7=FP1(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP1Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];

    %    
     %FP2   
       Cell8=FP2(tr(k)-1,tc(k)-1); Cell1=FP2(tr(k)-1,tc(k)); Cell2=FP2(tr(k)-1,tc(k)+1);...
            Cell3=FP2(tr(k),tc(k)+1);Cell4=FP2(tr(k)+1,tc(k)+1);...
            Cell5=FP2(tr(k)+1,tc(k)); Cell6=FP2(tr(k)+1,tc(k)-1); Cell7=FP2(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP2Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];     

    %
    %FP3   
       Cell8=FP3(tr(k)-1,tc(k)-1); Cell1=FP3(tr(k)-1,tc(k)); Cell2=FP3(tr(k)-1,tc(k)+1);...
            Cell3=FP3(tr(k),tc(k)+1);Cell4=FP3(tr(k)+1,tc(k)+1);...
            Cell5=FP3(tr(k)+1,tc(k)); Cell6=FP3(tr(k)+1,tc(k)-1); Cell7=FP3(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP3Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];      

    %FP4   
       Cell8=FP4(tr(k)-1,tc(k)-1); Cell1=FP4(tr(k)-1,tc(k)); Cell2=FP4(tr(k)-1,tc(k)+1);...
            Cell3=FP4(tr(k),tc(k)+1);Cell4=FP4(tr(k)+1,tc(k)+1);...
            Cell5=FP4(tr(k)+1,tc(k)); Cell6=FP4(tr(k)+1,tc(k)-1); Cell7=FP4(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP4Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];

            %
    %FP5   
       Cell8=FP5(tr(k)-1,tc(k)-1); Cell1=FP5(tr(k)-1,tc(k)); Cell2=FP5(tr(k)-1,tc(k)+1);...
            Cell3=FP5(tr(k),tc(k)+1);Cell4=FP5(tr(k)+1,tc(k)+1);...
            Cell5=FP5(tr(k)+1,tc(k)); Cell6=FP5(tr(k)+1,tc(k)-1); Cell7=FP5(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP5Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];      

    %
    %FP6   
       Cell8=FP6(tr(k)-1,tc(k)-1); Cell1=FP6(tr(k)-1,tc(k)); Cell2=FP6(tr(k)-1,tc(k)+1);...
            Cell3=FP6(tr(k),tc(k)+1);Cell4=FP6(tr(k)+1,tc(k)+1);...
            Cell5=FP6(tr(k)+1,tc(k)); Cell6=FP6(tr(k)+1,tc(k)-1); Cell7=FP6(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP6Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8]; 

    %
    %FP7   
      Cell8=FP7(tr(k)-1,tc(k)-1); Cell1=FP7(tr(k)-1,tc(k)); Cell2=FP7(tr(k)-1,tc(k)+1);...
            Cell3=FP7(tr(k),tc(k)+1);Cell4=FP7(tr(k)+1,tc(k)+1);...
            Cell5=FP7(tr(k)+1,tc(k)); Cell6=FP7(tr(k)+1,tc(k)-1); Cell7=FP7(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP7Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];

    %
    %FP8   
      Cell8=FP8(tr(k)-1,tc(k)-1); Cell1=FP8(tr(k)-1,tc(k)); Cell2=FP8(tr(k)-1,tc(k)+1);...
            Cell3=FP8(tr(k),tc(k)+1);Cell4=FP8(tr(k)+1,tc(k)+1);...
            Cell5=FP8(tr(k)+1,tc(k)); Cell6=FP8(tr(k)+1,tc(k)-1); Cell7=FP8(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    FP8Cellsmat=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8]; 
    
    
    %put all 8 1D vector matrices in one 2D matrix (path8matrix)
    
    path8matrix=[FP1Cellsmat FP2Cellsmat FP3Cellsmat FP4Cellsmat FP5Cellsmat...
        FP6Cellsmat FP7Cellsmat FP8Cellsmat];
 %by sum this matrix we calculate the sum of the flow in specific
 %direction. this will result 8 vectors 
    Vectors_Mag=nansum(path8matrix);
    %the angle is going counter clockwise starting from the positive x-axis
    %those vectors will have the following angles respectively
    %FP1 = 90 and FP2 =45 and 3 on x axis 
    Vectors_Ang=[90 45 0 315 270 225 180 135];
    %to calculate the resultant, decompose all vectors to x and y
    %components (xcomp ycomp)
    xcomp = Vectors_Mag .* cos(Vectors_Ang * pi/180);
    ycomp = Vectors_Mag .* sin(Vectors_Ang * pi/180);

    %sum all the components in x direction and y direction
xsum = nansum(xcomp);
ysum = nansum(ycomp);
%calculate the resultant although it not needed here
resultant = sqrt(xsum^2 + ysum^2);%resultant magnitude is not needed

resang = (atan (ysum/xsum))*180/pi; %calculate the angle of the resultant


%if the sign of one component is - then the resultant should be in quarter 2 or 4
if sign(xsum) == -1;
		resultant_angle = 180 + resang;
	elseif sign(ysum)== -1 ;
		resultant_angle = 360 + resang;
	else 
		resultant_angle = resang;
end;		
%# %

FPtemp=zeros(8,1);
%check if it is pointing to on cell if yes give 100% flow to that
%direction
mm=0;
one_drainage_direction=0;

Cell_count2=0;
%if one_drainage_direction == 0;
%%this is to correct case 5
%all cells are higher than the centre cell except one is same elevation
%then the flow will be 100% to than direction
Cellz8=ZT(tr(k)-1,tc(k)-1); Cellz1=ZT(tr(k)-1,tc(k)); Cellz2=ZT(tr(k)-1,tc(k)+1);...
            Cellz3=ZT(tr(k),tc(k)+1);Cellz4=ZT(tr(k)+1,tc(k)+1);...
            Cellz5=ZT(tr(k)+1,tc(k)); Cellz6=ZT(tr(k)+1,tc(k)-1); Cellz7=ZT(tr(k),tc(k)-1);
        Cellz10=ZT(tr(k),tc(k));
    %Putting all 8 cells in a vector matrix
    Cellsmatelv=[Cellz1; Cellz2; Cellz3; Cellz4; Cellz5; Cellz6; Cellz7; Cellz8];
    %
   %start from angle -90 to 135 to go with our cell numbering

  for theta=1:8
     if resultant_angle == Vectors_Ang(theta)
                 one_drainage_direction=theta;
         FPtemp(theta)=100; % give 100 percent to that dirct
        % p=2
         if Cellsmatelv(theta) > Cellz10 % check the elevation of that direct
           FPtemp(theta)=0;
         %  P=3
         end
     end
  end
   %%%%%
   for v=1:4 %cells number 1-8 =2-9
         %for v=1 then (v+1)is (2)refere to cell 1 , shifted numbering
         %check if the current cell has a flow path to cell 1 then check if
         %cell one has a flow path to cell 5 our cell
         if FPtemp(v) > 0 %the cell number that the flow is directed to it
            if path8matrix(v,v+4) > 0 %Contradictive
               Contradictive(tr(k),tc(k))=1;%lable 1 to Contradictive matrix
               contradictivecells=contradictivecells+1;
            FPtemp(v)=0; %set the flow to 0 in current cell
             
            end
         end
   end
     %the calculation is split to 2 portions to handle out of indexing
         for v=8:-1:5 %go from 8 to 5 do same as above
             if FPtemp(v) > 0
                if path8matrix(v,v-4) > 0 %Contradictive
          
         Contradictive(tr(k),tc(k))=1;%Contradictive
       contradictivecells=contradictivecells+1;
            FPtemp(v)=0; %set the flow to 0 in current cell
           
                end
            end
         end
   %FPtemp
     
%%%%%%
    
  
    
    m2=0;

    for nn=1:8
        if Cellz10 == Cellsmatelv(nn) && isnan(Cellsmatelv(nn))==0
            Cell_count2=Cell_count2+1;
            m2=nn; %if the valley is one cell wide then m is the cell index
        end
    end
    %end
    if Cell_count2 ==1
        FPtemp=zeros(8,1);%this is to correct case 7 where I get 100 flow in two directions
        %100 to one direction because full angle 45 90 135... and 100 to
        %other because just one cell is the same elvation
        FPtemp(m2)=100;
     % P=4
        %      
%Check for Contradictive flow
      
      
         %path8matrix=[FP1Cellsmat FP2Cellsmat FP3Cellsmat FP4Cellsmat FP5Cellsmat...
     %when Contradictive direct all flow to the other cell
     for v=1:4 %cells number 1-8
         
         %check if the current cell has a flow path to cell 1 then check if
         %cell one has a flow path to cell 5 our cell
         if FPtemp(v) > 0 %the cell number that the flow is directed to it
            if path8matrix(v,v+4) > 0 %Contradictive
               Contradictive(tr(k),tc(k))=1;%lable 1 to Contradictive matrix
               contradictivecells=contradictivecells+1;
            FPtemp(v)=0; %set the flow to 0 in current cell
             
            end
         end
     end
     %the calculation is split to 2 portions to handle out of indexing
         for v=8:-1:5 %go from 8 to 5 do same as above
         if FPtemp(v) > 0
            if path8matrix(v,v-4) > 0 %Contradictive
          
         Contradictive(tr(k),tc(k))=1;%Contradictive
       contradictivecells=contradictivecells+1;
            FPtemp(v)=0; %set the flow to 0 in current cell
           
           end
         end
         end
    %end of Contradictive check
    %  
        
    % FPtemp
    
     end %end of cell count2=0%end of case 5 two nieghbore flat cells

%end 

%%%%%%%

%if the resultant is directed to two cells. split the flow to two portions
if one_drainage_direction == 0 && Cell_count2 ~= 1;
% sectors depending on the angle are going counter clockwise starting from
% x-axis, s= 1 between cells 2&3, s=2 btween cells 2&1
%p=5
       s=fix(resultant_angle/45)+1;
        if s==1 || s==3 || s==5 || s==7 
            A=(resultant_angle -((s-1)*45))*pi/180;
        end
        if s==2 || s==4 || s==6 || s==8
          A=((s*45)- resultant_angle)*pi/180; 
        end
       
       %
        vector_a = (sin(A))/(sin(45*pi/180-A));
        Wa=vector_a/(vector_a +1);
        Wa=(fix(Wa*10000))/100;
        Wc=100-Wa;
   
   %the following are added to make the flow 100 percent directed to one cell
   %if the pecentage to the other cell is less than 1 pecent 
        if (Wa -Wc)>= 99
            Wa =100;
            Wc =0;
        end
        %oposit
        if (Wc -Wa)>= 99
            Wc =100;
            Wa =0;
        end
     %end of case
        
     
     
     %subtract one (1) from the index to find the cell number
      if  s==1
           FPtemp(2)=Wa;
           FPtemp(3)=Wc;
   elseif s==2
           FPtemp(1)=Wc;
           FPtemp(2)=Wa;
   elseif s==3
           FPtemp(8)=Wa;
           FPtemp(1)=Wc;
   elseif s==4
           FPtemp(7)=Wc;
           FPtemp(8)=Wa;
   elseif s==5
           FPtemp(6)=Wa;
           FPtemp(7)=Wc;
   elseif s==6
           FPtemp(5)=Wc;
           FPtemp(6)=Wa;
   elseif s==7
           FPtemp(4)=Wa;
           FPtemp(5)=Wc;
        elseif s==8
            FPtemp(3)=Wc;
           FPtemp(4)=Wa;     
      end
      
      %Check for Contradictive flow
      %copy two cells to make the calculation possible


      
         %path8matrix=[FP1Cellsmat FP2Cellsmat FP3Cellsmat FP4Cellsmat FP5Cellsmat...
     %when Contradictive direct all flow to the other cell
     for v=1:4 %cells number 1-8 =2-9

         %check if the current cell has a flow path to cell 1 then check if
         %cell one has a flow path to cell 5 our cell
         if FPtemp(v) > 0 %the cell number that the flow is directed to it
            if path8matrix(v,v+4) > 0 %Contradictive
               Contradictive(tr(k),tc(k))=1;%lable 1 to Contradictive matrix
               contradictivecells=contradictivecells+1;
            FPtemp(v)=0; %set the flow to 0 in current cell
            %%%% 
            
            for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
                 end
             end
            
                        
            
            end
         end
     end
     %the calculation is split to 2 portions to handle out of indexing
    for v=8:-1:5 %go from 8 to 5 do same as above
         if FPtemp(v) > 0
            if path8matrix(v,v-4) > 0 %Contradictive
               FPtemp(v)=0;
         Contradictive(tr(k),tc(k))=1;%Contradictive
       contradictivecells=contradictivecells+1; 
             
             for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
                 end
             end
            
           end
         end
    end
     %check again if the flow from the one cell is also Contradictive give drainage path 0
     for v=1:4
         if FPtemp(v) > 0
            if path8matrix(v,v+4) > 0 %Contradictive
            FPtemp(v)=0;
                           Contradictive(tr(k),tc(k))=2;%Contradictive
                    contradictivecells2=contradictivecells2+1; 
            end
         end
     end
         for v=8:-1:5
         if FPtemp(v) > 0
            if path8matrix(v,v-4) > 0 %Contradictive
               FPtemp(v)=0;
                              Contradictive(tr(k),tc(k))=2;%Contradictive
                    contradictivecells2=contradictivecells2+1;              
           end
         end
         end
       %FPtemp
     
    
       
end

%check if there is flow to a higher cell
for ff=1:8
         if Cellsmatelv(ff) > Cellz10 && FPtemp(ff)>0
         
             FPtemp(ff)=0;
             for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
         %  p=6
                 end
             end
            
         end
end

%check if the diagonal flow is crossing then the cell is sink
if FPtemp(1) > 0 % if the flow to cell 1 is diagonal
    if path8matrix(8,3) > 0 || path8matrix(2,7) > 0
        FPtemp(1) = 0;
        cross=cross + 1;
        for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
         
                 end
        end
    end
end

if FPtemp(3) > 0 % if the flow to cel3 1 is diagonal
    if path8matrix(2,5) > 0 || path8matrix(4,1) > 0
        FPtemp(3) = 0;
       cross=cross + 1;
        for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
                 end
        end
    end
end

if FPtemp(5) > 0 % if the flow to cell 5 is diagonal
    if path8matrix(4,7) > 0 || path8matrix(6,3) > 0
        FPtemp(5) = 0;
        cross=cross + 1;
        for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
                 end
        end
    end
end

if FPtemp(7) > 0 % if the flow to cell 7 is diagonal
    if path8matrix(6,1) > 0 || path8matrix(8,5) > 0
        FPtemp(7) = 0;
        cross=cross + 1;
        for fff=1:8
                 if FPtemp(fff)>0
                    FPtemp(fff)=100;
                 end
        end
    end
end
%FPtemp
%give the calculated flowpath values in FPtemp to the correct matrix
    FP1(tr(k),tc(k))=FPtemp(1);
    FP2(tr(k),tc(k))=FPtemp(2);
    FP3(tr(k),tc(k))=FPtemp(3);
    FP4(tr(k),tc(k))=FPtemp(4);
    FP5(tr(k),tc(k))=FPtemp(5);
    FP6(tr(k),tc(k))=FPtemp(6);
    FP7(tr(k),tc(k))=FPtemp(7);
    FP8(tr(k),tc(k))=FPtemp(8);
%check the matrix as done
    Check_Matrix(tr(k),tc(k))=1;
    flat_cells_vector(tr(k),tc(k))=0;
    counter=counter - 1

end

    
end

%return back to calculate the number of neighbor cells with defined
%flowpath again
end
