

function [zz,trackup]=track_upstream(FP1,FP2,FP3,FP4,FP5,FP6,FP7,FP8,INan,nrows,ncols,target_r,target_c)

%In this function the flow is tracked up. 
% at first we need to flag a cell by giving the row and column number for
% the target cell
% the function will creat new grid with 1 in all cells that has flow to the
% target cell. all other cells will get the value of 0

% target_r=55;
% target_c=110;
%
FP8(INan) = 0;
FP1(INan) = 0;
FP2(INan) = 0;
FP3(INan) = 0;
FP4(INan) = 0;
FP5(INan) = 0;
FP6(INan) = 0;
FP7(INan) = 0;

trackup=zeros(nrows,ncols);

%put all cells aorund this cell in a matrix and do the same for all 8
%directions 

z=1; %zone number
trackup(target_r,target_c)=z;
LP=1;
while LP>0;

[tr_up,tc_up]=find(trackup ==z);
[n,trash]=size(tr_up); %find n the size of that matrix


LP=0;
for k=1:n %Go through all zone cells
    


for i8=1:8
    
           if FP4(tr_up(k)-1,tc_up(k)-1)>0 && trackup(tr_up(k)-1,tc_up(k)-1) == 0
               trackup(tr_up(k)-1,tc_up(k)-1) = z+1;
               LP=1;
           end
               
           if FP5(tr_up(k)-1,tc_up(k))>0 && trackup(tr_up(k)-1,tc_up(k)) == 0
               trackup(tr_up(k)-1,tc_up(k)) = z+1;
               LP=1;
           end
           if FP6(tr_up(k)-1,tc_up(k)+1)>0 && trackup(tr_up(k)-1,tc_up(k)+1) == 0
               trackup(tr_up(k)-1,tc_up(k)+1) = z+1;
               LP=1;
           end
           if FP7(tr_up(k),tc_up(k)+1)>0 && trackup(tr_up(k),tc_up(k)+1) == 0
               trackup(tr_up(k),tc_up(k)+1) = z+1;
               LP=1;
           end
           if FP8(tr_up(k)+1,tc_up(k)+1)>0 && trackup(tr_up(k)+1,tc_up(k)+1) == 0
               trackup(tr_up(k)+1,tc_up(k)+1) = z+1;
               LP=1;
           end
           if FP1(tr_up(k)+1,tc_up(k))>0 && trackup(tr_up(k)+1,tc_up(k)) == 0
               trackup(tr_up(k)+1,tc_up(k)) = z+1;
               LP=1;
           end
           if FP2(tr_up(k)+1,tc_up(k)-1)>0 && trackup(tr_up(k)+1,tc_up(k)-1) == 0
               trackup(tr_up(k)+1,tc_up(k)-1) = z+1;
               LP=1;
           end
           if FP3(tr_up(k),tc_up(k)-1)>0 && trackup(tr_up(k),tc_up(k)-1) == 0
               trackup(tr_up(k),tc_up(k)-1) = z+1;
               LP=1;
           end
%n=sum(sum(track_up == 0));
%full_matrix_loop=0;


end

end
z=z+1;
clear tr_up;
clear tc_up;
end

trackup(trackup>1)=1;
zz=sum(sum(trackup ==1));%# number of cells
trackup(INan)= NaN;
% 
